unit ExDragDropMenuDMUnit;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Forms,
    SxComObj,
    SxDataModule, SxCustShlObj, SxDragDropMenu, Menus, SxContextMenu,
    SxPopupMenu, Controls;

type
  TSxDragDropModule = class(TSxModule)
    DragDropMenu: TSxDragDropMenu;
    SxPopupMenu: TSxPopupMenu;
    CreateHardLinkHere1: TMenuItem;
    procedure DragDropMenuUpdateRegistry(Sender: TObject;
      Register: Boolean);
    procedure CreateHardLinkhere1Click(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

uses ComServ, Dialogs, SxTools, RequestFormUnit;

{$R *.DFM}

procedure TSxDragDropModule.DragDropMenuUpdateRegistry(Sender: TObject;
  Register: Boolean);
begin
  if (Register) and (Win32Platform=VER_PLATFORM_WIN32_NT) then
     MessageDlg('Note: this shell extension will work only with NTFS volumes.', mtWarning, [mbOK], 0)
  else
  if Register then
     MessageDlg('This example works only with Windows NT/2000/XP on a NTFS '+#13+#10+'volumes.', mtError, [mbOK], 0);
end;

procedure TSxDragDropModule.CreateHardLinkhere1Click(Sender: TObject);
var
  i:Integer;
  SourceFile,DestinationFile:String;
begin
  RequestForm:=TRequestForm.CreateParented(DragDropMenu.ExplorerWnd);
  try
    RequestForm.lbFiles.Items.Assign(DragDropMenu.Files);
    if RequestForm.ShowModal<>mrOK then
       Exit;
    for i:=0 to DragDropMenu.Files.Count-1 do
    begin
      SourceFile:=DragDropMenu.Files[i];
      DestinationFile:=IncludeTrailingBackslash(DragDropMenu.InitFolder)+ExtractFileName(SourceFile);
      if FileExists(SourceFile) then
         if not CreateHardLink(PChar(DestinationFile),PChar(SourceFile),nil) then
            MessageDlg('Error creating hard link here.', mtError, [mbOK], 0);
    end;
  finally
    RequestForm.Free;
  end;
end;

initialization
    RegisterSxDataModule(ComServer,TSxDragDropModule);
end.
